// casView.cpp : implementation of the CCasView class
//

#include "stdafx.h"
#include "cas.h"

#include "casSet.h"
#include "casDoc.h"
#include "casView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCasView

IMPLEMENT_DYNCREATE(CCasView, CRecordView)

BEGIN_MESSAGE_MAP(CCasView, CRecordView)
	//{{AFX_MSG_MAP(CCasView)
	ON_BN_CLICKED(IDC_ADD_REC, OnAddRec)
	ON_BN_CLICKED(IDC_DEL_REC, OnDelRec)
	ON_BN_CLICKED(IDC_REFR_REC, OnRefrRec)
	ON_BN_CLICKED(IDC_BINAR_BUTT, OnBinarButt)
	ON_BN_CLICKED(IDC_BUTT_UPDAT_OLE, OnButtUpdatOle)
	ON_BN_CLICKED(IDC_BUTT_UPDAT_RASTER, OnButtUpdatRaster)	
	//}}AFX_MSG_MAP
	// Standard printing commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCasView construction/destruction

CCasView::CCasView()
	: CRecordView(CCasView::IDD)
{
	//{{AFX_DATA_INIT(CCasView)
	m_pSet = NULL;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_bAddMode = FALSE;
	m_bAktuatizovatOLE = 0;
	m_bAktuatizovatRaster = 0;
	m_bFirstCall = 1; 
	m_bFirstCallRaster = 1;
}

CCasView::~CCasView()
{
}

void CCasView::DoDataExchange(CDataExchange* pDX)
{
	CRecordView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCasView)
	DDX_Control(pDX, IDC_EDIT3, m_ctrlPTIME);
	DDX_Control(pDX, IDC_EDIT4, m_ctrlPTIMESTAMP);
	DDX_Control(pDX, IDC_EDIT2, m_ctrlPDATE);
	DDX_FieldText(pDX, IDC_EDIT1, m_pSet->m_PSHORT, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT5, m_pSet->m_PTEXT, m_pSet);
	//}}AFX_DATA_MAP
	// Nsledujc fce neobsahuj mechanismus vjimek a validaci dat
	DoDataTimeExchange(pDX); // Uivatelsk fce pro asov poloky
	DoBinaryExchange(pDX);// Uivatelsk fce pro binrn poloku PBINARY
	DoRasterExchange(pDX); // Uivatelsk fce pro test poloky RASTER
	DoOLEPictureExchange(pDX);// Uivatelsk fce pro test poloky POLE	
}

BOOL CCasView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRecordView::PreCreateWindow(cs);
}

void CCasView::OnInitialUpdate()
{
	m_pSet = &GetDocument()->m_casSet;
// Ukzka formtu datumu a asu pi filtrovn
//	m_pSet->m_strFilter = "PDATE > 1.1.1975 AND PTIME > 06:05:25";	 
	m_pSet->m_strSort = "PSHORT"; 

	m_pSet->m_pDatabase = GetDocument()->GetDatabase();
	if (!m_pSet->m_pDatabase->IsOpen())
		return;

	CRecordView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CCasView diagnostics

#ifdef _DEBUG
void CCasView::AssertValid() const
{
	CRecordView::AssertValid();
}

void CCasView::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CCasDoc* CCasView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCasDoc)));
	return (CCasDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCasView database support
CRecordset* CCasView::OnGetRecordset()
{
	return m_pSet;
}


/////////////////////////////////////////////////////////////////////////////
// CCasView message handlers

void CCasView::OnAddRec() 
{
	m_pSet->AddNew();	
	m_pSet->SetFieldNull(NULL);
	m_bAddMode = TRUE;	
	UpdateData(FALSE);			
}

void CCasView::OnDelRec() 
{
	m_pSet->Delete();   
	m_pSet->MoveNext();
	if (m_pSet->IsEOF()) m_pSet->MoveLast();
	if (m_pSet->IsBOF()) m_pSet->SetFieldNull(NULL);
	m_pSet->Requery();
	UpdateData(FALSE);		
}

void CCasView::OnRefrRec() 
{	
	if (m_bAddMode)
	{
		m_pSet->Move(AFX_MOVE_REFRESH);
		m_bAddMode = FALSE;
	}

	UpdateData(FALSE);		
}

BOOL CCasView::OnMove(UINT nIDMoveCommand) 
{
	if (m_bAddMode) { 
		m_bAddMode = FALSE;	
		UpdateData(TRUE);
		m_pSet->Update();
		m_pSet->Requery();
		UpdateData(TRUE);
	}		
		 
	BOOL bRetVal = CRecordView::OnMove(nIDMoveCommand);
	static RECT rec = {5,125,230,270};	
	InvalidateRect(&rec);
	return bRetVal;
}

void CCasView::OnDraw(CDC* pDC) 
{
	DrawBitmapToView();
	DrawOLEBitmapToView();
}

void CCasView::DoDataTimeExchange(CDataExchange* pDX)
{
// Uivatelsk procedura pro asov poloky: Vmna daj mezi atributy databzov tabulky a edit boxy 
// pro asov poloky TIME, DATE, TIMESTAMP. 

	CString m_PDATE, m_PTIME, m_PTIMESTAMP; 
	if (pDX->m_bSaveAndValidate) 
	// Kontrol -> dat. prvek
	{
	int nYear, nMonth, nDay, nHour,	nMinu, nSec;

	m_ctrlPDATE.GetWindowText(m_PDATE);
	if (m_PDATE != "")
	{nDay = atoi(m_PDATE.Left(2)); 	nMonth = atoi(m_PDATE.Mid(3, 5));  	nYear = atoi(m_PDATE.Right(4));
	m_pSet->m_PDATE = CTime( nYear , nMonth, nDay, 0, 0, 0);};

    m_ctrlPTIME.GetWindowText(m_PTIME);
	if (m_PTIME != "")
	{nHour = atoi(m_PTIME.Left(2)); 	nMinu = atoi(m_PTIME.Mid(3, 5)); nSec = atoi(m_PTIME.Right(2));	
	m_pSet->m_PTIME = CTime( 1980 , 1, 1, nHour, nMinu, nSec);};

	m_ctrlPTIMESTAMP.GetWindowText(m_PTIMESTAMP);
	if (m_PTIMESTAMP != "")
	{	nDay =	 atoi(m_PTIMESTAMP.Left(2));
		nMonth = atoi(m_PTIMESTAMP.Mid(3, 5));
		nYear =  atoi(m_PTIMESTAMP.Mid(6,10));
		nHour =  atoi(m_PTIMESTAMP.Mid(11,13));
		nMinu =  atoi(m_PTIMESTAMP.Mid(14,16));
		nSec =   atoi(m_PTIMESTAMP.Right(2));
	m_pSet->m_PTIMESTAMP = CTime( nYear , nMonth, nDay, nHour, nMinu, nSec);};

	}
	else 
	// dat. prvek -> kontrol 
	{
	// Datum
	CTime td = m_pSet->m_PDATE;	m_PDATE = td.Format("%d.%m.%Y"); 
	m_ctrlPDATE.SetWindowText(m_PDATE);
	// Cas
	m_pSet->GetFieldValue( "PTIME", m_PTIME);
	m_ctrlPTIME.SetWindowText(m_PTIME);
	// TimeStamp
	CTime ts = m_pSet->m_PTIMESTAMP; m_PTIMESTAMP = ts.Format("%d.%m.%Y %H:%M:%S");
	m_ctrlPTIMESTAMP.SetWindowText(m_PTIMESTAMP); 
	}
}

void CCasView::OnBinarButt() 
{
// viz pozn. v uivatelsk metod
// void CCasView::DoBinaryExchange(CDataExchange* pDX)
	int i, chyba = 0;
	for (i = 0; i <= 11; i++)
		if (i == m_pSet->m_PBINARY.GetAt(i)) chyba++ ;
		if (chyba == 12) MessageBeep(0);			
}

void CCasView::DoBinaryExchange(CDataExchange* pDX)
{
//	Tento kd a kd ve void CCasView::OnBinaryButt() je uveden
//  jen za elem testovn PBINARY - test, zda lze do tohoto
//	atributu dn zapisovat a st.
   if (pDX->m_bSaveAndValidate) {
		int i;
		for (i = 0; i <= 11; i++)
		  m_pSet->m_PBINARY.SetAt(i, i); 	
   }
}

void CCasView::DoRasterExchange(CDataExchange* pDX)
{
	if (pDX->m_bSaveAndValidate)// Z "ovladacho prvku" do dat. prvku m_pSet->m_PRASTER
	{
		if (m_bAktuatizovatRaster == 1) 
		{
/*
	Do poloky PRASTER aktulnho zznamu zkopruji data z atributu
	PRASTER prvnho zznamu. Tato data jsou skladovna 
	v poli bajt CByteArray m_baCopieFirstPRASTER.
	Tm je otestovna monost zpisu do atributu typu RASTER. 
	Formt dat je DIB bitmapa. 
*/	
			m_nSizeRaster = m_baCopieFirstPRASTER.GetSize();	
			if (m_nSizeRaster != 0)
			{		
				HGLOBAL Data = GlobalAlloc(GMEM_MOVEABLE, m_nSizeRaster);
				if (Data == 0) return;	
				LPVOID  lpDataLok = GlobalLock( Data );
				m_lpDataByteRaster = (BYTE*)lpDataLok;

				for (DWORD nIndex = 0; nIndex < m_nSizeRaster; nIndex++)
				 m_lpDataByteRaster[nIndex]  = m_baCopieFirstPRASTER.GetAt(nIndex);        		

				HGLOBAL hData = m_pSet->m_PRASTER.m_hData;
				GlobalUnlock( hData );
				HGLOBAL HandRet = GlobalFree( hData );
		
				// Nastavit nov data
				m_pSet->m_PRASTER.m_dwDataLength = m_nSizeRaster;
				m_pSet->m_PRASTER.m_hData = Data;

				m_pSet->SetFieldNull( &(m_pSet->m_PRASTER), FALSE );
				m_pSet->SetFieldDirty( &(m_pSet->m_PRASTER), TRUE );
			} // if (m_nSizeRaster != 0)	
			m_bAktuatizovatRaster = 0;
		}//if (m_bAktuatizovatRaster == 1) 
	}
	else// Z dat. prvku m_pSet->m_PRASTER do "ovladacho prvku" 
	{
		DrawBitmapToView();	
	}
}

void CCasView::DoOLEPictureExchange(CDataExchange* pDX)
{
	if (pDX->m_bSaveAndValidate)
	// Z "ovladacho prvku" do dat. prvku m_pSet->m_POLE
	{
		if (m_bAktuatizovatOLE == 1) 
		{
/*
	Do poloky POLE aktulnho zznamu zkopruji data z atributu
	POLE prvnho zznamu. Tato data jsou skladovna 
	v poli bajt CByteArray m_baCopieFirstPOLE.
	Tm je otestovna monost zpisu do atributu typu OLE 
	Formt dat je DIB bitmapa 
*/					

			m_nSize = m_baCopieFirstPOLE.GetSize();	
			if (m_nSize != 0)
			{		
				HGLOBAL Data = GlobalAlloc(GMEM_MOVEABLE, m_nSize);
				if (Data == 0) return;	
				LPVOID  lpDataLok = GlobalLock( Data );
				m_lpDataBYTE = (BYTE*)lpDataLok;

				for (DWORD nIndex = 0; nIndex < m_nSize; nIndex++)
				 m_lpDataBYTE[nIndex]  = m_baCopieFirstPOLE.GetAt(nIndex);        		

				HGLOBAL hData = m_pSet->m_POLE.m_hData;
				GlobalUnlock( hData );
				HGLOBAL HandRet = GlobalFree( hData );
		
				// Nastavit nov data
				m_pSet->m_POLE.m_dwDataLength = m_nSize;
				m_pSet->m_POLE.m_hData = Data;

				m_pSet->SetFieldNull( &(m_pSet->m_POLE), FALSE );
				m_pSet->SetFieldDirty( &(m_pSet->m_POLE), TRUE );
			} // if (m_nSize != 0)	
		m_bAktuatizovatOLE = 0;
	    } // if (m_bAktuatizovatOLE == 1) 	   
	}
	else// Z dat. prvku m_pSet->m_POLE do "ovladacho prvku" 
	{
		DrawOLEBitmapToView();
	}
}

void CCasView::DrawBitmapToView()
{
/**** Uivatelsk fce pro vykreslen bitmapy z poloky RASTER ***/
	#define P_BINFO ((BITMAPINFOHEADER*)lpDib)

	HGLOBAL hData = m_pSet->m_PRASTER.m_hData;
	if (hData == 0) return;
	LPVOID  lpData = GlobalLock(hData);	
	m_nSizeRaster = ((BITMAPFILEHEADER*)lpData)->bfSize;
	m_lpDataByteRaster = (BYTE*)lpData;
	BYTE* lpDib = m_lpDataByteRaster + sizeof(BITMAPFILEHEADER);		
	BYTE* lpDibBits  = GetDibBitsAddr(lpDib);
	DWORD cxDib = P_BINFO->biWidth;
	DWORD cyDib = P_BINFO->biHeight; 
	CClientDC dc(this);

	CRecordsetStatus rStatus;
	m_pSet->GetStatus(rStatus);
	if ( rStatus.m_lCurrentRecord == 0){  // Prvn zznam
	  m_bAktuatizovatRaster = 0;
	  if ( m_bFirstCallRaster == 1 ) { // Prvn voln - uloen poloky	 
		SaveFirstPRASTER();
		m_bFirstCallRaster = 0; // Pole se ji znova ukldat nebude 
	  }	
	} 
	else // Druh i dal zznam
	if (m_bAktuatizovatRaster == 1)
	{
/*	Do poloky PRASTER aktulnho zznamu zkopruji data z atributu
	PRASTER prvnho zznamu. Tuto kopii se pozdji pokusm zapsat 
	do PRASTER jinho zznamu - aktulnho zznamu, na nm 
	kliknu na tlatko UPDATE PRASTER.
	Tm je otestovna monost zpisu do atributu typu RASTER 
	Formt dat je DIB bitmapa 
*/
		m_nSizeRaster = m_baCopieFirstPRASTER.GetSize();
		if (m_nSizeRaster != 0)
		{		
			HGLOBAL Data = GlobalAlloc(GMEM_MOVEABLE, m_nSizeRaster);			
			LPVOID  lpDataLok = GlobalLock( Data );
			m_lpDataByteRaster = (BYTE*)lpDataLok;

/*
 Zkoprovn obsahu poloky PRASTER prvnho zznamu uloenho 
 v poli m_baCopieFirstPRASTER do pole m_lpDataByteRaster	
*/
			for (DWORD nIndex = 0; nIndex < m_nSizeRaster; nIndex++)
		     m_lpDataByteRaster[nIndex]  = m_baCopieFirstPRASTER.GetAt(nIndex);        		

			// Zruit star data
			BOOL Er1 = GlobalUnlock( hData );
			HGLOBAL HandRet = GlobalFree( hData );
		
			// Nastavit nov data
			m_pSet->m_PRASTER.m_dwDataLength = m_nSizeRaster;
			m_pSet->m_PRASTER.m_hData = Data;
		
			lpDib = m_lpDataByteRaster + sizeof(BITMAPFILEHEADER); 
			lpDibBits  = GetDibBitsAddr(lpDib);
			cxDib = P_BINFO->biWidth;
			cyDib = P_BINFO->biHeight; 					
		}	
	}
	 
	/******/ SetDIBitsToDevice( /*****************************/
    dc.m_hDC,		// handle of device context 
    110,		// x-coordinate of upper-left corner of dest. rect. 
    130,	// y-coordinate of upper-left corner of dest. rect. 
    cxDib,			// source rectangle width 
    cyDib,			// source rectangle height 
    0,		// x-coordinate of lower-left corner of source rect. 
    0,		// y-coordinate of lower-left corner of source rect. 
    0,				// first scan line in array 
    cyDib,			// number of scan lines 
    (LPSTR)lpDibBits,		// address of array with DIB bits 
    (BITMAPINFO*)lpDib,// address of structure with bitmap info. 
    DIB_RGB_COLORS	   // RGB or palette indices 
   );	
 	GlobalUnlock(hData);	 
}

void CCasView::DrawOLEBitmapToView()
{
/**** Uivatelsk fce pro vykreslen bitmapy z poloky OLE ***/
	#define P_BINFO ((BITMAPINFOHEADER*)lpDib)				
	  				
	HGLOBAL hData = m_pSet->m_POLE.m_hData;
	if (hData == 0) return;	
	LPVOID  lpData = GlobalLock(hData);
	m_nSize = ((BITMAPFILEHEADER*)lpData)->bfSize;	
	m_lpDataBYTE = (BYTE*)lpData;
	BYTE* lpDib = m_lpDataBYTE + sizeof(BITMAPFILEHEADER); 
	BYTE* lpDibBits  = GetDibBitsAddr(lpDib);
	DWORD cxDib = P_BINFO->biWidth;
	DWORD cyDib = P_BINFO->biHeight; 
	CClientDC dc(this);

	CRecordsetStatus rStatus;
	m_pSet->GetStatus(rStatus);
	if ( rStatus.m_lCurrentRecord == 0){  // Prvn zznam
	  m_bAktuatizovatOLE = 0;
	  if ( m_bFirstCall == 1 ) { // Prvn voln - uloen pole	 
		SaveFirstPOLE();
		m_bFirstCall = 0; // Pole se ji znova ukldat nebude 
	  }	
	} 
	else // Druh i dal zznam
	if (m_bAktuatizovatOLE == 1)
	{
/*	Hodnota m_bAktuatizovatOLE nastavena na 1 v OnButtUpdatOle() a
	anulovna v DoOLEPictureExchange(CDataExchange* pDX).
    Do poloky POLE aktulnho zznamu zkopruji data z atributu
	POLE prvnho zznamu. Tuto kopii se pozdji pokusm zapsat do
	POLE jineho zznamu - aktulnho zznamu, na nm kliknu na
	tlatko UPDATE POLE. Tm je otestovna monost zpisu do 
	atributu typu OLE
	Formt dat je DIB bitmapa.		
*/
		m_nSize = m_baCopieFirstPOLE.GetSize();
		if (m_nSize != 0)
		{		
			HGLOBAL Data = GlobalAlloc(GMEM_MOVEABLE, m_nSize);			
			LPVOID  lpDataLok = GlobalLock( Data );
			m_lpDataBYTE = (BYTE*)lpDataLok;

/*
 Zkoprovn obsahu poloky POLE prvnho zznamu uloenho 
 v poli m_baCopieFirstPOLE do pole m_lpDataBYTE	
*/
			for (DWORD nIndex = 0; nIndex < m_nSize; nIndex++)
		     m_lpDataBYTE[nIndex]  = m_baCopieFirstPOLE.GetAt(nIndex);        		

			// Zruit star data
			BOOL Er1 = GlobalUnlock( hData );
			HGLOBAL HandRet = GlobalFree( hData );
		
			// Nastavit nov data
			m_pSet->m_POLE.m_dwDataLength = m_nSize;
			m_pSet->m_POLE.m_hData = Data;
		
			lpDib = m_lpDataBYTE + sizeof(BITMAPFILEHEADER); 
			lpDibBits  = GetDibBitsAddr(lpDib);
			cxDib = P_BINFO->biWidth;
			cyDib = P_BINFO->biHeight; 					
		}	
	}
	
	/******/ SetDIBitsToDevice( /*****************************/
    dc.m_hDC,		// handle of device context 
    10,		// x-coordinate of upper-left corner of dest. rect. 
    130,	// y-coordinate of upper-left corner of dest. rect. 
    cxDib,			// source rectangle width 
    cyDib,			// source rectangle height 
    0,		// x-coordinate of lower-left corner of source rect. 
    0,		// y-coordinate of lower-left corner of source rect. 
    0,				// first scan line in array 
    cyDib,			// number of scan lines 
    (LPSTR)lpDibBits,  // address of array with DIB bits 
    (BITMAPINFO*)lpDib,// address of structure with bitmap info. 
    DIB_RGB_COLORS	   // RGB or palette indices 
   );	
	  GlobalUnlock(hData);	 
}

BYTE* CCasView::GetDibBitsAddr(BYTE* lpDib)
{
/* Uivatelsk fce pro zskn adresy (pole s DIB bity)
   jakoto vstupnho parametru SetDIBitsToDevice
*/   
#define P_BINFO ((BITMAPINFOHEADER*)lpDib)

DWORD dwNumColors = P_BINFO->biClrUsed;
WORD  dwBitCount = P_BINFO->biBitCount;
DWORD dwBitInfoSize = P_BINFO->biSize;	
 if (dwNumColors == 0)
	if (dwNumColors != 24) 
	  dwNumColors = 1L << dwBitCount;
	else
	  dwNumColors = 0;	
DWORD dwColorTableSize = dwNumColors * sizeof(RGBQUAD);
return lpDib + dwBitInfoSize + dwColorTableSize; 
}

void CCasView::OnButtUpdatRaster() 
{ /* Pi pesunu na jin zznam se provede
    (nebo m_bAktuatizovatRaster == 1) aktualizace poloky
	PRASTER hodnotou z prvnho zznamu a nastav se
	m_bAktuatizovatRaster = 0
  */

	m_bAktuatizovatRaster = 1;	
	DrawBitmapToView();	
	static RECT rec = {5,125,230,270};	
	InvalidateRect(&rec);
}

void CCasView::OnButtUpdatOle() 
{ /* Pi pesunu na jin zznam se provede
    (nebo m_bAktuatizovatOLE == 1) aktualizace poloky
	POLE hodnotou z prvnho zznamu a nastav se
	m_bAktuatizovatOLE = 0	
  */
	
	m_bAktuatizovatOLE = 1;		
	DrawOLEBitmapToView();
	static RECT rec = {5,125,230,270};	
	InvalidateRect(&rec);
}

void CCasView::SaveFirstPOLE()
{// Kd pro uloen POLE z prvnho zznamu
   
/*  ulo obsah poloky POLE prvnho zznamu 
	(rStatus.m_lCurrentRecord == 0) do pole bajt
	CByteArray m_baCopieFirstPOLE pro jeho ppadn pozdj
	pouit (m_bAktuatizovatOLE == 1) - zkoprovn do jinho 
	zznamu.
*/	
	m_baCopieFirstPOLE.SetSize(m_nSize);
	if (m_nSize > 0) 
	 for (DWORD nIndex = 0; nIndex < m_nSize; nIndex++)
	   m_baCopieFirstPOLE.SetAt(nIndex, m_lpDataBYTE[nIndex]);		
}

void CCasView::SaveFirstPRASTER()
{// Kd pro uloen PRASTER z prvnho zznamu
   
/*  ulo obsah poloky PRASTER prvnho zznamu 
	(rStatus.m_lCurrentRecord == 0) do pole bajt
	CByteArray m_baCopieFirstPRASTER pro jeho ppadn pozdj
	pouit (m_bAktuatizovatRASTER == 1) - zkoprovn do jinho 
	zznamu.
*/	
	m_baCopieFirstPRASTER.SetSize(m_nSizeRaster);
	if (m_nSizeRaster > 0) 
	 for (DWORD nIndex = 0; nIndex < m_nSizeRaster; nIndex++)
	   m_baCopieFirstPRASTER.SetAt(nIndex, m_lpDataByteRaster[nIndex]);
}
